import { Component, Prop, Host, h } from '@stencil/core';
import { HeadingVarians, HeadingSectionVariants } from "../../utils/utils";
export class Heading {
    constructor() {
        this.heading = HeadingVarians.default;
        this.section = HeadingSectionVariants.default;
    }
    render() {
        const headingInVariants = this.heading in HeadingVarians;
        const classAttributes = ["hy-heading"];
        const sectionClassAttributes = [`hy-heading__${this.section}`].join(" ");
        return (h(Host, null, headingInVariants
            ? h("div", { class: "hy-heading__container" },
                h(this.heading, { class: classAttributes.join(" ") },
                    h("slot", null)),
                h("span", { class: sectionClassAttributes }))
            : h("div", { class: "hy-heading__container" },
                h(HeadingVarians.default, { class: classAttributes.join(" ") },
                    h("slot", null)),
                h("span", { class: sectionClassAttributes }))));
    }
    static get is() { return "hy-heading"; }
    static get encapsulation() { return "shadow"; }
    static get originalStyleUrls() { return {
        "$": ["heading.scss"]
    }; }
    static get styleUrls() { return {
        "$": ["heading.css"]
    }; }
    static get properties() { return {
        "heading": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "HeadingVarians",
                "resolved": "HeadingVarians.default | HeadingVarians.h2 | HeadingVarians.h3 | HeadingVarians.h4 | HeadingVarians.h5 | HeadingVarians.h6",
                "references": {
                    "HeadingVarians": {
                        "location": "import",
                        "path": "../../utils/utils"
                    }
                }
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "heading",
            "reflect": false,
            "defaultValue": "HeadingVarians.default"
        },
        "section": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "HeadingSectionVariants",
                "resolved": "HeadingSectionVariants.default | HeadingSectionVariants.subSection",
                "references": {
                    "HeadingSectionVariants": {
                        "location": "import",
                        "path": "../../utils/utils"
                    }
                }
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "section",
            "reflect": false,
            "defaultValue": "HeadingSectionVariants.default"
        }
    }; }
}
